/* Part of Replication files for Sarzosa and Urzua "Bullying Among Adolescents: 
   The Role of Skills" in QE.
   
   Miguel Sarzosa (msarzosa@purdue.edu)
   Sergio Urzua (surzua@econ.umd.edu)
   
   December 2020
*/

********************************************************************************
* 1. Creating variables
********************************************************************************

recode f4a1w (1 2 3 99 = 1) (4 = 2) (5 = 3) (6 = 4) (7 8 = 5), gen(FatherEdu)
gen FatherEduHSorLess = inlist(FatherEdu,1,2) if FatherEdu!=.

********************************************************************************
* 2. Tables
********************************************************************************
	
// District FE	
foreach Z in pbullies pfamtroubled {
	local j=0
	local strm	
	if "`Z'"=="pbullies" local filter "& bullydum==0"
	else local filter  //"FamilyTroubled"	
	foreach i in ageinmonths male oldersiblings lnmonthinc_pc liveswbothparents FatherEduHSorLess {
		local j = `j' + 1
		loca extra
		if "`i'"=="male" local extra "onlymen onlywomen"
		if "`i'"=="liveswbothparents" local filter "`filter' & f1a1w!=0"
		eststo m`j': qui areg `i' `Z' `extra' if wave==1 & f4a1w!=1 & lnmonthinc_pc !=. & rankclassscore_std!=. & schoolsbydist>1, abs(altFE) cluster(schlaw)
		local strm "`strm'  m`j'"	
	}
	esttab `strm' using "BalancingKYP2`Z'_DistrictFE.tex", /// 
		replace b(%7.3f) se(%6.3f) par starlevels(* 0.1 ** 0.05 *** 0.01) stats(N, fmt(%9.0fc)) nonum drop(onlymen onlywomen _cons) /// 
		collabels(none) frag  nolines nomti /// 
		substitute(pfamtroubled "\% Peer Violent Fam" ageinmonths "Age in Months" male "Male" oldersiblings OlderSiblings lnmonthinc_pc Lnmonthincpc liveswbothparents BothParents FatherEduHSorLess "FatherEdu<Coll") ///
		nonotes
}
foreach Z in pbullies pfamtroubled {
	local j=0
	local strm	
	if "`Z'"=="pbullies" local filter "& bullydum==0"
	else local filter  //"FamilyTroubled"	
	foreach i in ageinmonths male oldersiblings lnmonthinc_pc liveswbothparents FatherEduHSorLess {
		local j = `j' + 1
		loca extra
		if "`i'"=="male" local extra "onlymen onlywomen"
		if "`i'"=="liveswbothparents" local filter "`filter' & f1a1w!=0"
		eststo m`j': qui areg `i' `Z' `extra' if wave==1 & f4a1w!=1 & lnmonthinc_pc !=. & rankclassscore_std!=., abs(altFE) cluster(schlaw)
		local strm "`strm'  m`j'"	
	}
	esttab `strm' using "BalancingKYP3`Z'_DistrictFE.tex", /// 
		replace b(%7.3f) se(%6.3f) par starlevels(* 0.1 ** 0.05 *** 0.01) stats(N, fmt(%9.0fc)) nonum drop(onlymen onlywomen _cons) /// 
		collabels(none) frag  nolines nomti /// 
		substitute(pfamtroubled "\% Peer Violent Fam" ageinmonths "Age in Months" male "Male" oldersiblings OlderSiblings lnmonthinc_pc Lnmonthincpc liveswbothparents BothParents FatherEduHSorLess "FatherEdu<Coll") ///
		nonotes
}
foreach Z in pbullies pfamtroubled {
	local j=0
	local strm	
	if "`Z'"=="pbullies" local filter "& bullydum==0"
	else local filter  //"FamilyTroubled"	
	foreach i in ageinmonths male oldersiblings lnmonthinc_pc liveswbothparents FatherEduHSorLess {
		local j = `j' + 1
		loca extra
		if "`i'"=="male" local extra "onlymen onlywomen"
		if "`i'"=="liveswbothparents" local filter "`filter' & f1a1w!=0"
		eststo m`j': qui reg `i' `Z' `extra' totalstudentgrowth avg_moveout_adj avg_movein_adj avg_quit_adj taxrev_pc if wave==1 & f4a1w!=1 & lnmonthinc_pc !=. & rankclassscore_std!=. & schoolsbydist>1, cluster(altFE)
		local strm "`strm'  m`j'"	
	}
	esttab `strm' using "BalancingKYP3`Z'_DistrictChar.tex", /// 
		replace b(%7.3f) se(%6.3f) par starlevels(* 0.1 ** 0.05 *** 0.01) stats(N, fmt(%9.0fc)) nonum /// 
		drop(onlymen onlywomen totalstudentgrowth avg_moveout_adj avg_movein_adj avg_quit_adj taxrev_pc _cons) /// 
		collabels(none) frag  nolines nomti /// 
		substitute(pfamtroubled "\% Peer Violent Fam" ageinmonths "Age in Months" male "Male" oldersiblings OlderSiblings lnmonthinc_pc Lnmonthincpc liveswbothparents BothParents FatherEduHSorLess "FatherEdu<Coll") ///
		nonotes
}	

