*! heterofactor program
*! version 1.2.5
*! 		Branch out from version 1.2.4 to include 4 factors.
*!		Incorporates the residuals to save time
*!      Uses Simulated destibutions for steps where distributions already known 
*! Apr 2013
*! Miguel Sarzosa

capture program drop heterofactor
program heterofactor
	version 11
	if replay() {
		if ("`e(cmd)'" != "heterofactor") error 301
		Replay `0'
	}
	else Estimate `0'
end

capture program drop lfols
program lfols
  version 11
  args lnf xb lnsigma
  local y "$ML_y1"
  quietly replace `lnf' = ln(normalden(`y', `xb',exp(`lnsigma')))
end 

capture program drop Estimate
program Estimate, eclass sortpreserve
	version 11.0
	syntax varlist(min=2 numeric ts) [if] [in], [SCores(varlist ts) INDvarsc(varlist  ts) /// 
		TREATind(varname ts) INStrum(varlist ts) FACTORS(integer 1) NODES(integer 10) /// 
		EXP1(varlist ts) EXP2(varlist ts) EXP3(varlist ts) EXP4(varlist ts) /*OUTEQ2(varlist)*/ /// 
		TWOSTep FDISTonly NUMF1tests(integer 3) SCNDSTPonly LASTFonlytr choiceonly NOCHOICE TREATINDBEF(varlist ts) /// 
		seed(integer 12345) BINF1(integer 0) BINF2(integer 0) BINF3(integer 0) BINF4(integer 0)  /// 
		SIGMAMIXT11(real -10000) SIGMAMIXT12(real -10000) MIXTPROB1(real -10000) MUMIXT1(real -10000) ///
		SIGMAMIXT21(real -10000) SIGMAMIXT22(real -10000) MIXTPROB2(real -10000) MUMIXT2(real -10000) ///
		SIGMAMIXT31(real -10000) SIGMAMIXT32(real -10000) MIXTPROB3(real -10000) MUMIXT3(real -10000) ///
		SIGMAMIXT41(real -10000) SIGMAMIXT42(real -10000) MIXTPROB4(real -10000) MUMIXT4(real -10000) ///	
		RESVAR3(varname) RESVAR6(varname) RESVAR9(varname) RESVAR12(varname) /// 			 
		ST2(real 0) ST3(real 0) ST5(real 0) ST6(real 0) ST9(real 0) ST12(real 0) /// 
		CHOICEFIX gavar(varname) AV1(real -10000) AV2(real 0) AV3(real 0) AV4(real 0) /// 
		TREATIND2(varname ts) CHOICEINCHOICE CHOICEINCHFIX gavar1(varname) gavar0(varname) ///  
		VECAVLOADS1(namelist) VECAVLOADS0(namelist) ///		
		TRIANGULAR nohats initialreg inipar(namelist) joint Level(cilevel) noLOg *]	
	mlopts mlopts, `options'	
	marksample touse
	gettoken yvar indepvars: varlist, parse(" ")
	local nscores : word count `scores'	
	tokenize `scores'										
	forvalues i = 1/`nscores' {
		tempvar test`i'
		qui gen `test`i''  = ``i''
	}
	local indvarsc1 "`indvarsc' `exp1'"
	local indvarsc2 "`indvarsc' `exp2'"
	local indvarsc3 "`indvarsc' `exp3'"
	local indvarsc4 "`indvarsc' `exp4'"		
	local nx : word count `indepvars'
	local nz : word count `instrum'		
	local nq1 : word count `indvarsc1'
	local nq2 : word count `indvarsc2' 
	local nq3 : word count `indvarsc3'
	local nq4 : word count `indvarsc4'	 	
	local nZ = `nz' + 1
	local nX = `nx' + 1
	local nQ1 = `nq1' + 1
	local nQ2 = `nq2' + 1
	local nQ3 = `nq3' + 1		
	local nQ4 = `nq4' + 1			

	cap scalar drop nodes
	scalar define nodes = `nodes'
	
	if `binf1'>3 | `binf2'>3 | `binf3'>3 | `binf4'>3 {
		di as error "You have specified that at least test score is binary. Option defined incorrectly"
		error 100
	}
	if (inlist(`numf1tests',3,6,9)==0) {
		di as error "Option numf1tests must be either 3, 6 or 9. You specified `numf1tests'"
		error 100
	}	
	forvalues i = 1/`factors' {
		if (`binf`i''==1) local bint1f`i' "bint1"
		if `binf`i''==2 {
			local bint1f`i' "bint1"
			local bint2f`i' "bint2"
			if `numf1tests'>=6 {
				local bint3f`i' "bint3"
				local bint4f`i' "bint4"	
				if `numf1tests'==9 {
					local bint5f`i' "bint5"
					local bint6f`i' "bint6"					
				}			
			}
		}	
	}	
	
	if 	"`scndstponly'"!= ""  {
		if  `factors'==1 & (`sigmamixt11'==-10000 | `sigmamixt12'==-10000 | `mixtprob1'==-10000 | `mumixt1'==-10000) {
			di as error "If scndstponly option is specified while estimating a one factor model" /// 
				_newline "sigmamixt11(), sigmamixt12(), mixtprob1() and mumixt1() need to be specified"
			error 100
		}
		if  `factors'==2 & (`sigmamixt11'==-10000 | `sigmamixt12'==-10000 | `mixtprob1'==-10000 | `mumixt1'==-10000 |  /// 
							`sigmamixt21'==-10000 | `sigmamixt22'==-10000 | `mixtprob2'==-10000 | `mumixt2'==-10000) {
			di as error "If scndstponly option is specified while estimating a two factors model" /// 
				_newline "sigmamixt11(), sigmamixt12(), mixtprob1(), mumixt1(), sigmamixt21(), sigmamixt22(), mixtprob2(), mumixt2() need to be specified"
			error 100
		}
		if  `factors'==3 & (`sigmamixt11'==-10000 | `sigmamixt12'==-10000 | `mixtprob1'==-10000 | `mumixt1'==-10000 |  /// 
							`sigmamixt21'==-10000 | `sigmamixt22'==-10000 | `mixtprob2'==-10000 | `mumixt2'==-10000 |  ///
							`sigmamixt31'==-10000 | `sigmamixt32'==-10000 | `mixtprob3'==-10000 | `mumixt3'==-10000) {
			di as error "If scndstponly option is specified while estimating a two factors model" /// 
				_newline "sigmamixt11(), sigmamixt12(), mixtprob1(), mumixt1(), sigmamixt21(), sigmamixt22(), mixtprob2(), mumixt2()" /// 
				_newline "sigmamixt31(), sigmamixt32(), mixtprob3(), mumixt3() need to be specified"
			error 100
		}		
		if  `factors'==4 & (`sigmamixt11'==-10000 | `sigmamixt12'==-10000 | `mixtprob1'==-10000 | `mumixt1'==-10000 |  /// 
							`sigmamixt21'==-10000 | `sigmamixt22'==-10000 | `mixtprob2'==-10000 | `mumixt2'==-10000 |  ///
							`sigmamixt31'==-10000 | `sigmamixt32'==-10000 | `mixtprob3'==-10000 | `mumixt3'==-10000 |  /// 
							`sigmamixt41'==-10000 | `sigmamixt42'==-10000 | `mixtprob4'==-10000 | `mumixt4'==-10000 ) {
			di as error "If scndstponly option is specified while estimating a two factors model" /// 
				_newline "sigmamixt11(), sigmamixt12(), mixtprob1(), mumixt1(), sigmamixt21(), sigmamixt22(), mixtprob2(), mumixt2()" /// 
				_newline "sigmamixt31(), sigmamixt32(), mixtprob3(), mumixt3(), sigmamixt41(), sigmamixt42(), mixtprob4(), mumixt4() need to be specified"
			error 100
		}
		if "`treatind'"=="" & "`nochoice'"=="" { 
			di as error "treatind() and instrum() options required"			
			exit
		}	
	}
	
	if (`factors'==1 & "`scndstponly'"!="" & "`twostep'"=="") local twostep "twostep"
*	if (`factors'==1 & "`scndstponly'"!="" & "`nochoice'"!="" &"`choiceonly'"=="") local twostep "" // different but needed		
	if (`factors'==1 & "`fdistonly'"!="" & "`twostep'"=="") local twostep "twostep"	
	if (`factors'==1 & "`outeq2'"!="" & "`twostep'"=="") local twostep "twostep"
	if ("`scndstponly'"!="") local nohats "nohats"
	if ("`fdistonly'"!="") local nochoice "nochoice"
	if "`treatindbef'" !="" & "`choiceonly'"!="" & `factors'==2 { 
		local sameBBH "sameBBH"
		local choiceonly
	}	
	
	if "`joint'"!="" {
		local twostep "twostep"
		if `factors'!=2 {
			di as error "Number of factors using joint option needs to be 2"
			exit		
		}
	}
	if "`choicefix'"!="" & `av1'==-10000 {
		di as error "Need to specify at least av1 when choicefix option used"
		exit	
	}
	
	capture drop _fT* 
	capture drop _MTE_f
	if `factors'>4 | `factors'<1 {
		di as error "Number of factors used needs to be either 1, 2, 3 or 4"
		exit
	}

	markout `touse' `yvar' `indepvars' `treatind' `instrum' `scores' `indvarsc' `exp1' `exp2' `resvar3' `resvar6' `resvar9' `resvar12' `gavar' `gavar1' `gavar0' `treatindbef'

	qui count if `touse'
	if `r(N)' == 0 {
		error 2000
	}
	capture drop __touse
	gen __touse = `touse'
	
	qui set seed `seed'
	
	if ("`lastfonlytr'"!="" & "`fdistonly'"=="") local fdistonly "fdistonly"
	if ("`lastfonlytr'"!="") local pass = `factors'-1
	
	// Initial Values
	if "`initialreg'"!="" {
		di as text "Estimating" as result " Initial Values Vector"
		if "`treatindbef'"!="" {
			forvalues j=0/1 {
				local fin = 4
//				forvalues i=1/`fin' {
				foreach i in 1 2 3 4 6 {
					if (`i'==6) ml model lf lfols ("``i''`j'": `test`i'' = `indvarsc2') (sigT`i'`j':) if `treatindbef'==`j'
					else ml model lf lfols ("``i''`j'": `test`i'' = `indvarsc1',nocons) (sigT`i'`j':) if `treatindbef'==`j'
					qui ml maximize
					mat A=e(b)
					mat bT`i'`j' = A[1,"``i''`j':"]
					local sdT`i'`j' = _b["sigT`i'`j'":_cons]			
				}			
			}
//			forvalues i=3/6 {
			foreach i in 5 {
				local j=1
				ml model lf lfols ("``i''`j'": `test`i'' = `indvarsc1',nocons) (sigT`i'`j':) if `touse'
				qui ml maximize
				mat A=e(b)
				mat bT`i'`j' = A[1,"``i''`j':"]
				local sdT`i'`j' = _b["sigT`i'`j'":_cons]			
			}						
			qui probit `treatindbef' `instrum'
			mat bprobbef = e(b)	
		}	
		
		local ini_opt "init(ini_val) search(off)"	
		cap mat drop A
		cap mat drop b

	}
	else local ini_opt "search(on)"
		
	if "`scndstponly'"== "" {
		di as text "Running" as result " Factor Model"		
		
		if "`triangular'"!="" {	
					
			if "`joint'"!="" {

				if "`initialreg'"!="" {
					if ("`inipar'" != "") mat ini_par = `inipar'
					if ("`inipar'" == "") mat ini_par = J(1,10,0), `sdT11', `sdT21', `sdT31', `sdT10', `sdT20', /*`sdT30',*/ `sdT41', `sdT51', `sdT61', /*`sdT40', `sdT50', `sdT60',*/ -1.212177, -.4600632, -1.066037, -1.579659, .6359868, -.0818591, -.5191532, -1.144656, -.8156312	
					mat rown ini_par = y1
//					mat coln ini_par = av1:_cons av2:_cons aT111:_cons aT211:_cons aT311:_cons aT411:_cons aT421:_cons aT511:_cons aT521:_cons aT110:_cons aT210:_cons aT410:_cons aT420:_cons sigT11:_cons sigT21:_cons sigT31:_cons sigT10:_cons sigT20:_cons sigT30:_cons sigT41:_cons sigT51:_cons sigT61:_cons sigT40:_cons sigT60:_cons sigf11:_cons sigf12:_cons sigf21:_cons sigf22:_cons p1:_cons mu11:_cons mu21:_cons rho1:_cons rho2:_cons 
					mat coln ini_par = av1:_cons av2:_cons aT111:_cons aT211:_cons aT311:_cons aT411:_cons aT421:_cons aT511:_cons aT521:_cons aT110:_cons aT210:_cons aT410:_cons aT420:_cons sigT11:_cons sigT21:_cons sigT31:_cons sigT10:_cons sigT20:_cons sigT30:_cons sigT41:_cons sigT51:_cons sigT61:_cons sigT40:_cons sigT60:_cons sigf11:_cons sigf12:_cons sigf21:_cons sigf22:_cons p1:_cons mu11:_cons mu21:_cons rho1:_cons rho2:_cons 
					mat ini_val = bprobbef, bT11, bT21, bT31, bT41, bT51, bT61, bT10, bT20, bT30, bT40, /*bT50,*/ bT60, ini_par	
				}
				scalar define tr = 1
//reg `yvar' `treatindbef' `instrum' `indvarsc1' if `touse'
				ml model d0 factorevaljointprodtr2HHM() ("`treatindbef'": `treatindbef' = `instrum') /// 
										("`1'1": `test1' = `indvarsc1',nocons) ("`2'1": `test2' = `indvarsc1',nocons) ("`3'1": `test3' = `indvarsc1',nocons) ///
										("`4'1": `test4' = `indvarsc1',nocons) ("`5'1": `test5' = `indvarsc1',nocons) ("`6'1": `test6' = `indvarsc2')  ///
										("`1'0": `test1' = `indvarsc1',nocons) ("`2'0": `test2' = `indvarsc1',nocons) ("`3'0": `test3' = `indvarsc1',nocons) ///
										("`4'0": `test4' = `indvarsc1',nocons)  /*("`5'0": `test5' = `indvarsc2')*/	 ("`6'0": `test6' = `indvarsc2')  ///
										/av1 /av2 /aT111 /aT211 /aT311 /aT411 /aT421 /aT511 /aT521 /aT110 /aT210 /aT410 /aT420 /// 
										/sigT11 /sigT21 /sigT31 /sigT10 /sigT20 /sigT30 /sigT41 /sigT51 /sigT61 /sigT40 /sigT60 ///
										/sigf11 /sigf12 /sigf21 /sigf22 /p1 /mu11 /mu21 /rho1 /rho2 ///
										if `touse', /// 							
										missing `mlopts' `log' 	maximize `ini_opt'

				local numpar = 33

				ereturn scalar k_aux = `numpar'		
		
				Replay	, level(`level')	
				
			}
		} // end if triangular!=""

	} // end if scndstponly	==""

	if ("`numpar'"=="") local numpar = `nmpr'			
	
/*	if "`joint'"!="" {
		mat b =e(b)
		foreach sclr in 11 21 42 52 {
			local a`sclr' = _b[aT`sclr':_cons]
		}
		foreach sclr in sigf11 sigf12 sigf21 sigf22 p1 mu11 mu21 rho1 rho2 {
			local `sclr' = _b[`sclr':_cons]
		}
		foreach sclr in aT11 aT21 aT42 aT52 mu11 mu21 {
			scalar define `sclr' = _b[`sclr':_cons]
		}
		if "`triangular'"!="" {
			foreach sclr in 41 51 {
				local a`sclr' = _b[aT`sclr':_cons]
			}
			foreach sclr in aT41 aT51 {
				scalar define `sclr' = _b[`sclr':_cons]
			}
		}
		
		foreach sclr in sigT4 sigT5 sigT6 sigT1 sigT2 sigT3 sigf11 sigf12 sigf21 sigf22 {
			scalar define `sclr' = exp(_b[`sclr':_cons])
		}
		foreach sclr in 11 12 21 22 {
			scalar define sig`sclr' = exp(_b[sigf`sclr':_cons])
		}						
		scalar define p1 = invlogit(_b[p1:_cons])
		scalar define rho1 = cos(_pi*invlogit(_b[rho1:_cons]))
		scalar define rho2 = cos(_pi*invlogit(_b[rho2:_cons]))
		
		qui {
			forvalues i = 1/6 {
				tempvar that`i' 
				mat score `that`i''= b if `touse', eq(#`i')
				cap drop __res`i'
				gen __res`i' = `test`i'' - `that`i''	
				mat betaT`i' = b[1,"``i'':"]														
			}
			cap drop mixt1
			cap drop mixt2						
			dist2f `sigf11' `sigf12' `sigf21' `sigf22' `p1' `mu11' `mu21' `rho1' `rho2'
		}
		if ("`triangular'"!="") mat f1coeff = `a11', `a21', `a41', `a42', `a51', `a52', `sigf11', `sigf12', `sigf21', `sigf22', `p1', `mu11', `mu21', `rho1', `rho2'
		if ("`triangular'"=="") mat f1coeff = `a11', `a21', `a42', `a52', `sigf11', `sigf12', `sigf21', `sigf22', `p1', `mu11', `mu21', `rho1', `rho2'		
		mat f2coeff = f1coeff // because is joint	
	}	
*/	
	di as text "Done Estimating Factor Model"
	
	
	cap drop __touse
//	cap drop __res*
//	cap drop __TD*
	cap scalar drop nodes	
	ereturn local cmd heterofactor	
	
end


cap program drop Replay
program Replay
	syntax [, Level(cilevel) EForm ]
	/*if `e(k_aux)' {
		local sigma1 diparm(sig1,  label("sigma_1"))
		local sigmT1 diparm(sigT1, label("sigma_T1"))
		local sigmT2 diparm(sigT2, label("sigma_T2"))
		local sigmaf diparm(sigf,  label("sigma_f"))
	}*/

	ml display , level(`level') ///`sigma1' `sigmT1' `sigmT2' `sigmaf'

end

