cap program drop simulfactjoint
program simulfactjoint, sortpreserve eclass
	syntax anything(name=vars) [if] [in], IDVAR(varname) ///
		[Ndraws(integer 100) grid(integer 20) /// 
		GAVECTOR(namelist) loadingv1(real 0) loadingv2(real 0) /// 
		y1vector(namelist) loadingy11(real 0) loadingy12(real 0) SIGY1(real 0) ///
		y0vector(namelist) loadingy01(real 0) loadingy02(real 0) SIGY0(real 0) ///
		sigmamixt11(real 0) sigmamixt12(real 0) mumixt1(real 0) mixtprob(real 0) ///		
		sigmamixt21(real 0) sigmamixt22(real 0) mumixt2(real 0) rmixt1(real 0) rmixt2(real 0) /// 
		TREATind(varname) INStrum(varlist) ette BS DIST NL simulsave(string asis)] 
		
		
/*		
		 FACTORS(integer 1) /// 
		  V(namelist) CENTER(real 0) /// 

		title1(string asis) title2(string asis)  /// 
		graphsave(string asis)  EVALP(integer 50) /// 
		CRITVAL(real 1.96) SIMCHOICE LOGY FACTDENS ]
*/		
		
	gettoken yvar controls: vars, parse(" ")
	marksample touse 
	markout `touse' `controls' `treatind' `instrum'

	local factors=2      // # of Factors have to be 2. We are in a correlated world
	local realf=`factors'

	qui count if `touse'
	if `r(N)' == 0 {
		error 2000
	}	
	local totobs = `r(N)'
	forvalues d=0/1 {
		qui count if `touse' & `treatind'==`d'
		local totobs`d' = `r(N)'
	}	
	local ATE=("`y0vector'"!="")
	local D =("`gavector'"!="")
	local Y =("`y1vector'"!="" & "`y0vector'"=="")
		
	mat ve = 1,(exp(`sigy1'))^2,(exp(`sigy0'))^2
	mat varerror = diag(ve)
	mat drop ve
	
	tempvar intr1 intr0 intrG
	mat score `intr1' = `y1vector'
	if (`ATE'==1) mat score `intr0' = `y0vector'
	if (`D'==1) mat score `intrG' = `gavector'
	
	preserve
		qui keep if `touse'
		qui des,s
		local idobs = `r(N)'
		di "Using `r(N)' observations" _n
		
		qui sum `yvar'
		local meany = `r(mean)'
		local sdy = `r(sd)'
		if `D'==1 {
			qui sum `treatind'
			local meand = `r(mean)'
			
			local stringD "ED"		
		}	
		if `ATE'==1 {
			tempvar expy
			qui sum `yvar' if `treatind'==1
			local meany1 = `r(mean)'
			local sdy1 = `r(sd)'			
			qui sum `yvar' if `treatind'==0
			local meany0 = `r(mean)'
			local sdy0 = `r(sd)'	

			if "`logy'"!="" local streATE "eEy Ey eEy0 Ey0 EATE ETTE"
			else local streATE "Ey Ey0 EATE ETTE"				
			local strEyin "Eyin"							
		}
		if (`Y'==1) local strEylwcy "Ey"
			
		di as text "Simulations (" as result "`ndraws'" as text ")"
		di as text "----|--- 1 ---|--- 2 ---|--- 3 ---|--- 4 ---|--- 5"
		forvalues i=1/`ndraws' {	
			
			qui random_dist2f `sigmamixt11' `sigmamixt12' `sigmamixt21' `sigmamixt22' `mixtprob' `mumixt1' `mumixt2' `rmixt1' `rmixt2'
			qui drawnorm eps error1 error0, cov(varerror)
			rename mixt1 _mixt1_
			rename mixt2 _mixt2_

			if (`ATE'==0 & `D'==0) {
				qui gen Ey = `intr1' + (`loadingy11'*_mixt1_) + (`loadingy12'*_mixt2_) + error1
				if ("`logy'"!="") qui gen eEy = exp(Ey)					
			}	
			if (`D'==1) qui gen ED = (`intrG' + (`loadingv1'*_mixt1_) + (`loadingv2'*_mixt2_) + eps>0)

			if `ATE'==1 {		
				qui gen Ey  = `intr1' + (`loadingy11'*_mixt1_) + (`loadingy12'*_mixt2_) + error1
				qui gen Ey0 = `intr0' + (`loadingy01'*_mixt1_) + (`loadingy02'*_mixt2_) + error0
				
				if "`logy'"=="" & "`nl'"=="" {
					qui gen EATE = `intr1' - `intr0' + ((`loadingy11'-`loadingy01')*_mixt1_) + ((`loadingy12'-`loadingy02')*_mixt2_) 						
					qui gen ETTE = `intr1' - `intr0' + ((`loadingy11'-`loadingy01')*_mixt1_) + ((`loadingy12'-`loadingy02')*_mixt2_) if ED==1					
				}	
				if "`logy'"!="" {
					qui gen eEy = exp(Ey)	
					qui gen eEy0 = exp(Ey0)						
					qui gen EATE = eEy - eEy0
					qui gen ETTE = eEy - eEy0 if ED==1				
				}
				if "`nl'"!="" {
					qui gen eEy = (Ey>0)	
					qui gen eEy0 = (Ey0>0)						
					qui gen EATE = eEy - eEy0
					qui gen ETTE = eEy - eEy0 if ED==1	
					drop Ey Ey0
					rename eEy Ey
					rename eEy0 Ey0
				}
				qui gen Eyin = (ED*EATE)				
			}	
			
			keep _mixt1_ _mixt2_ `strEylwcy' `streATE' `strEyin' `stringD' `idvar' `treatind' `controls' `touse' `intr1' `intr0' `intrG'
			gen rep = `i'
			tempfile rep`i'
			qui save `rep`i''
			keep `idvar' `treatind' `controls' `strgavr' `touse' `intr1' `intr0' `intrG'
			di _continue as text "."
			local ind = round(`i'/50) - (`i'/50)
			if (`ind'==0) di as text "(`i')" 			

		}	
		drop _all
		use `rep1'
		forvalues i=2/`ndraws' {
			append using `rep`i''
		}
		if "`dist'"!="" | "`test'"!="" {
			local lss=strlen(`simulsave')
			local simulsave =substr(`simulsave',1,`lss')
		}	
		if "`dist'"!="" {	
			keep _mixt1_ _mixt2_ ED
			tempfile allsims
			save `allsims'
			keep if ED==0
			drop ED
			save "`simulsave'/DistfED0", replace
			use `allsims'
			keep if ED==1
			drop ED
			save "`simulsave'/DistfED1", replace
		}		
		if "`test'"!="" {		
			keep T? EDbef			
			save "`simulsave'/TestsW1", replace
		}
		if "`dist'"!="" | "`test'"!="" {
			mat b = 1
			ereturn mat b1=b
			exit
		}		

		di _newline as text "Estimating Marginal Effects" _newline
			
		qui distinct `idvar'
		local N = `r(ndistinct)'			
		
		forvalues i = 1/`factors' {
			xtile gridstep`i' =_mixt`i'_, n(`grid') 
		}		

		if `Y'==1 {
			qui sum Ey // Already toused
			local mEy = `r(mean)'	
		}	
		if `ATE'==1 {	
			qui sum Ey if ED==1 //& ED==`treatind' // Already toused
			local mEy1 = `r(mean)'
			local sEy1 = `r(sd)'
			qui sum Ey0 if ED==0 //& ED==`treatind' // Already toused
			local mEy0 = `r(mean)'				
			local sEy0 = `r(sd)'			
			qui gen EDy1Dy0 = ED*Ey + (1-ED)*Ey0  // weighted average
			qui sum EDy1Dy0
			local mEDy1Dy0 = `r(mean)'
			local sEDy1Dy0 = `r(sd)'	
			qui sum EATE
			local mEATE = `r(mean)'
			qui sum ETTE
			local mETTE = `r(mean)'			

			* moments of each quantile
			local strmEATE 
			local strNamemEATE
			local strmEATE1f
			local strNamemEATE1f
			local strmETTE 
			local strNamemETTE
			local strmETTE1f
			local strNamemETTE1f
			forvalues j = 1/`realf' {
				forvalues f = 1/`realf' {
					forvalues i = 1/`grid' {
											
						if `f'==`j' {
							qui sum EATE if gridstep`j'==`i' 
							if `r(N)'<20 local strmEATE1f "`mEy`ff'_ptil' \ 0 \ 0 "
							if `r(N)'>=20 local strmEATE1f "`strmEATE1f' \ `r(mean)' \ `r(sd)'"
							local strNamemEATE1f "`strNamemEATE1f' EATE_`j'`f'_`i' sEATE_`j'`f'_`i'"
							if "`ette'"!="" {								
								qui sum ETTE if gridstep`j'==`i' 
								if `r(N)'<20 local strmETTE1f "`strmETTE1f' \ 0 \ 0 "
								if `r(N)'>=20 local strmETTE1f "`strmETTE1f' \ `r(mean)' \ `r(sd)'"
								local strNamemETTE1f "`strNamemETTE1f' ETTE_`j'`f'_`i' sETTE_`j'`f'_`i'"
							}	
						}								
						forvalues h = 1/`grid' {
							if `f'>`j' {
								qui sum EATE if gridstep`j'==`i' & gridstep`f'==`h'
								if `r(N)'<20 local strmEATE "`strmEATE' \ 0 \ 0 "
								if `r(N)'>=20 local strmEATE "`strmEATE' \ `r(mean)' \ `r(sd)'"
								local strNamemEATE "`strNamemEATE' EATE_`j'`f'_`i'`h' sEATE_`j'`f'_`i'`h'"
								if "`ette'"!="" {
									qui sum ETTE if gridstep`j'==`i' & gridstep`f'==`h'
									if `r(N)'<20 local strmETTE "`strmETTE' \ 0 \ 0 "
									if `r(N)'>=20 local strmETTE "`strmETTE' \ `r(mean)' \ `r(sd)'"
									local strNamemETTE "`strNamemETTE' ETTE_`j'`f'_`i'`h' sETTE_`j'`f'_`i'`h'"
								}	
							}	
						}							
					}
				}		
			}	
		}				
		 
		if `D'==1 {
			qui sum ED 
			local mD = `r(mean)'
			local sD = `r(sd)'			
		}
			
//		tempfile mixtlong
//		qui save `mixtlong', replace
		
		* Kdensity 
		if "`bs'"=="" & `D'==1 & "`factdens'"!="" {
			forvalues i = 1/`factors' {
				forvalues d=0/1 {
					use `mixtlong',clear
					kdensity _mixt`i'_ if ED==`d', nograph n(50) generate(xgrid`i'`d' dens`i'`d')
					keep xgrid`i'`d' dens`i'`d'
					qui outsheet xgrid`i'`d' dens`i'`d' using `simulsave'kdens`i'`d.txt', replace  
				}	
			}
			use `mixtlong', clear
		}

		* Var-Cov
		if "`bs'"=="" { 
			if `Y'==1 {
				mat vc = `v'
				local sizevmat = colsof(`vector1') + `factors'
				mat vc = vc[1..`sizevmat',1..`sizevmat']	
					
				local ef = `factors' - 1
				forvalues h = 1/`grid' {
					forvalues i = 1/`factors' {
						local j = `i'- 1			
						local r = `factors' - `j' - 1					
						qui sum _mixt`i'_ if gridstep`i'==`h'
						if (`i'==1) mat mvec = meanc \ `r(mean)' \ J(`r',1,0)
						if (inrange(`i',2,`ef')) mat mvec = meanc \ J(`j',1,0) \ `r(mean)' \ J(`r',1,0)
						if (`i'==`factors') mat mvec = meanc \ J(`j',1,0) \ `r(mean)'
						mat v_`i'_`h' = mvec'*vc*mvec
						local se_`i'_`h' = sqrt((v_`i'_`h'[1,1] + (exp(`sigy')^2)) / (`totobs'/`grid'))
						mat drop v_`i'_`h' mvec
					}	
				}
				mat mvec = meanc \ J(`factors',1,0)	
				mat v__ = mvec'*vc*mvec	
				local se_mean = sqrt((v__[1,1] + (exp(`sigy')^2)) / `totobs')	
				mat drop mvec v__
			}
			if `D'==1 {
				if ("`triangular'"=="") {
					mat vc = `v'					
					if `ATE'==1 {
						if (`realf' == 1) mat vc = (`v'["`treatind':","`treatind':"],`v'["`treatind':","av1:"])\(`v'["av1:","`treatind':"],`v'["av1:","av1:"])
						if (`realf' == 2) mat vc = (`v'["`treatind':","`treatind':"],`v'["`treatind':","av1:"],`v'["`treatind':","av2:"])\(`v'["av1:","`treatind':"],`v'["av1:","av1:"],`v'["av1:","av2:"])\(`v'["av2:","`treatind':"],`v'["av2:","av1:"],`v'["av2:","av2:"])
						if (`factors'==3) mat vc = (`v'["`treatind':","`treatind':"],`v'["`treatind':","av1:"],`v'["`treatind':","av2:"],`v'["`treatind':","av3:"])\(`v'["av1:","`treatind':"],`v'["av1:","av1:"],`v'["av1:","av2:"],`v'["av1:","av3:"])\(`v'["av2:","`treatind':"],`v'["av2:","av1:"],`v'["av2:","av2:"],`v'["av2:","av3:"])\(`v'["av3:","`treatind':"],`v'["av3:","av1:"],`v'["av3:","av2:"],`v'["av3:","av3:"])	
						if (`factors'==4) mat vc = (`v'["`treatind':","`treatind':"],`v'["`treatind':","av1:"],`v'["`treatind':","av2:"],`v'["`treatind':","av3:"],`v'["`treatind':","av4:"])\(`v'["av1:","`treatind':"],`v'["av1:","av1:"],`v'["av1:","av2:"],`v'["av1:","av3:"],`v'["av1:","av4:"])\(`v'["av2:","`treatind':"],`v'["av2:","av1:"],`v'["av2:","av2:"],`v'["av2:","av3:"],`v'["av2:","av4:"])\(`v'["av3:","`treatind':"],`v'["av3:","av1:"],`v'["av3:","av2:"],`v'["av3:","av3:"],`v'["av3:","av4:"])\(`v'["av4:","`treatind':"],`v'["av4:","av1:"],`v'["av4:","av2:"],`v'["av4:","av3:"],`v'["av4:","av4:"])	
					}
					if `ATE'==0 {
						if (`factors'==3) mat vc = (`v'["`treatind':","`treatind':"],`v'["`treatind':","av1:"],`v'["`treatind':","av2:"],`v'["`treatind':","av2:"])\(`v'["av1:","`treatind':"],`v'["av1:","av1:"],`v'["av1:","av2:"],`v'["av1:","av2:"])\(`v'["av2:","`treatind':"],`v'["av2:","av1:"],`v'["av2:","av2:"],`v'["av2:","av2:"])\(`v'["av2:","`treatind':"],`v'["av2:","av1:"],`v'["av2:","av2:"],`v'["av2:","av2:"])	
					}
				}			
				else {
					if `ATE'==0 {
						local totpar = colsof(`v')
						local limit = `totpar'-(`factors'-1)
						mat vc = `v'[1..`limit',1..`limit']
					}				
				}
				local ef = `factors' - 1
				forvalues h = 1/`grid' {
					forvalues i = 1/`factors' {
						qui sum _mixt`i'_ if gridstep`i'==`h'
						mata: gradient(`loadingv`i'', `r(mean)',`i',`factors')
						local r = rowsof(gratz)-1
						if (`realf'==1) mat gratz = gratz[1..`r',1] 
						mat v_`i'_`h' = gratz'*vc*gratz + 1
						local seD_`i'_`h' = sqrt(v_`i'_`h'[1,1] / (`totobs'/`grid'))
						mat drop v_`i'_`h' 
					}	
				}			
				mat mvec = meanZ \ J(`realf',1,0)	
				mat v__ = mvec'*vc*mvec	
				local seD_mean = sqrt(v__[1,1] / `totobs')	
				mat drop mvec v__			
			}
			if `ATE'==1 { 
				if `realf'==2 {
					mat vc = `v'
					mat vc1 = (vc["`yvar'1:","`yvar'1:"],vc["`yvar'1:","a11:"],vc["`yvar'1:","a12:"])\(vc["a11:","`yvar'1:"],vc["a11:","a11:"],vc["a11:","a12:"])\(vc["a12:","`yvar'1:"],vc["a12:","a11:"],vc["a12:","a12:"])
					mat vc0 = (vc["`yvar'0:","`yvar'0:"],vc["`yvar'0:","a01:"],vc["`yvar'0:","a02:"])\(vc["a01:","`yvar'0:"],vc["a01:","a01:"],vc["a01:","a02:"])\(vc["a02:","`yvar'0:"],vc["a02:","a01:"],vc["a02:","a02:"])	
					mat cov = (vc["`yvar'1:","`yvar'0:"],vc["`yvar'1:","a01:"],vc["`yvar'1:","a02:"])\(vc["a11:","`yvar'0:"],vc["a11:","a01:"],vc["a11:","a02:"])\(vc["a12:","`yvar'0:"],vc["a12:","a01:"],vc["a12:","a02:"])
				}
				if `realf'==1 {
					mat vc = `v'
					mat vc1 = (vc["`yvar'1:","`yvar'1:"],vc["`yvar'1:","a11:"])\(vc["a11:","`yvar'1:"],vc["a11:","a11:"])
					mat vc0 = (vc["`yvar'0:","`yvar'0:"],vc["`yvar'0:","a01:"])\(vc["a01:","`yvar'0:"],vc["a01:","a01:"])	
					mat cov = (vc["`yvar'1:","`yvar'0:"],vc["`yvar'1:","a01:"])\(vc["a11:","`yvar'0:"],vc["a11:","a01:"])
				}				
				mat vc = vc1 + vc0 - cov - cov
			
				local ef = `realf' - 1
				forvalues h = 1/`grid' {
					forvalues i = 1/`realf' {
						local j = `i'- 1			
						local r = `realf' - `j' - 1					
						qui sum _mixt`i'_ if gridstep`i'==`h'
						if (`i'==1) mat mvec = meanc \ `r(mean)'					
						if `realf' > 1 {
							if (`i'!=`factors') mat mvec = meanc \ `r(mean)' \ J(`r',1,0)
							if (inrange(`i',2,`ef')) mat mvec = meanc \ J(`j',1,0) \ `r(mean)' \ J(`r',1,0)
							if (`i'==`factors') mat mvec = meanc \ J(`j',1,0) \ `r(mean)'
						}
						mat v_`i'_`h' = mvec'*vc*mvec
//						local seATE_`i'_`h' = sqrt((v_`i'_`h'[1,1] + (exp(`sigy')^2) + (exp(`sigy0')^2)) / `totobs')
						local seATE_`i'_`h' = sqrt((v_`i'_`h'[1,1] + (exp(`sigy')^2) + (exp(`sigy0')^2)) / (`totobs'/`grid')) //because SE should depend only on those affecting each quantile
						mat drop v_`i'_`h' mvec
					}	
				}
		
				* For simulated Y0 Y1
				local sigy1 = `sigy'
				forvalues d=0/1 {
					mat mvec = meanc`d' \ J(`realf',1,0)	
					mat v__ = mvec'*vc`d'*mvec	
					local se_meanY`d' = sqrt((v__[1,1] + (exp(`sigy`d'')^2)) / `totobs')	
					mat drop mvec v__
				}
				
			}
		}
				
		* Goodness of Fit
		if "`bs'"=="" {
			file open StoreGFit using "`simulsave'_GF.txt", write replace
			file write StoreGFit "Moment" _tab "Estimate" _n
			if `D'==0 {
				local ciu = round(`mEy'+(1.96*`se_mean'),0.0001)
				local cid = round(`mEy'-(1.96*`se_mean'),0.0001)			
				di "Simulated Mean Expected Outcome, controls at mean: `mEy' CI(`cid' - `ciu'); Actual: `meany'"
				file write StoreGFit "EY" _tab "`mEy'" _n
				file write StoreGFit "SEMEANY" _tab "`se_mean'" _n
				local sd_mean = `se_mean'*sqrt(`totobs')
				file write StoreGFit "SD_EY" _tab "`sd_mean'" _n
				file write StoreGFit "ActualY" _tab "`meany'" _n
				file write StoreGFit "ActualSD" _tab "`sdy'" _n	
			}
			if `D'==1 {
				local ciu = round(`mD'+(1.96*`seD_mean'),0.0001)
				local cid = round(`mD'-(1.96*`seD_mean'),0.0001)		
				di "Simulated Mean Probability of Choice,  controls at mean: `mD' CI(`cid' - `ciu'); Actual: `meand'"
				file write StoreGFit "ED" _tab "`mD'" _n
				file write StoreGFit "SEMEAND" _tab "`seD_mean'" _n
			}
			if `ATE'==1 {
				forvalues d=0/1 {
					local ciu = round(`mEy`d''+(1.96*`se_meanY`d''),0.0001)
					local cid = round(`mEy`d''-(1.96*`se_meanY`d''),0.0001)			
					di "Simulated Mean Expected Outcome `treatind'==`d', controls at mean: `mEy`d'' CI(`cid' - `ciu'); Actual: `meany`d''"				
					file write StoreGFit "EY`d'" _tab "`mEy`d''" _n
					file write StoreGFit "SEMEANY`d'" _tab "`se_meanY`d''" _n
					local sd_meanY`d' = `se_meanY`d''*sqrt(`totobs')
					file write StoreGFit "SD_EY`d'" _tab "`sd_meanY`d''" _n				
					file write StoreGFit "ActualY`d'" _tab "`meany`d''" _n				
					file write StoreGFit "ActualSD`d'" _tab "`sdy`d''" _n				
				}				
			}
		}			
		else {
			if `D'==0 {
				mat b = `mEy'
				mat rown b = EY
			}
			if `ATE'==1 {
				if "`ette'"!="" {
					local strmEATE1f 
					local strNamemEATE1f 
					local strmEATE 
					local strNamemEATE 
				}
				if "`ette'"=="" {
					local strmETTE1f
					local strNamemETTE1f
					local strmETTE
					local strNamemETTE				
				}
				mat b = `mEy0' \ `mEy1' \ `mD' \ `mEDy1Dy0' \ `mEATE' \ `mETTE' `strmEATE' `strmEATE1f' `strmETTE' `strmETTE1f' \ `sEy0' \ `sEy1' \ `sD' \ `sEDy1Dy0' 
				mat rown b = EY0 EY1 ED EDy1Dy0 EATE ETTE `strNamemEATE' `strNamemEATE1f' `strNamemETTE' `strNamemETTE1f' sY0 sY1 sD sDy1Dy0 
			}	
			mat coln b = "`yvar'"
			mat b = b'
			ereturn mat b1=b
		}
				
		cap file close _all
		if "`bs'"=="" {
			forvalues j = 1/`realf' {
				forvalues f = 1/`realf' {
					if `j'<=`f' {
						if (`Y'==1) file open Ey`j'`f' using "`simulsave'`j'`f'.txt", write replace
						if (`ATE'==1) file open EATE`j'`f' using "`simulsave'`j'`f'_ATE.txt", write replace
						if (`ATE'==1) file open ETTE`j'`f' using "`simulsave'`j'`f'_TTE.txt", write replace
						if (`D'==1) file open Eydi`j'`f' using "`simulsave'`j'`f'_di.txt", write replace
						if (`D'==1) file write Eydi`j'`f' "Indirect" _n
						if (`D'==1 & "`simchoice'"!="") file open ED`j'`f' using "`simulsave'`j'`f'_D.txt", write replace				
					}	
				}
			}		
		
			forvalues j = 1/`realf' {
				forvalues f = 1/`realf' {
					forvalues i = 1/`grid' {
						if `j'<=`f' { 
							if (`Y'==1) file write Ey`j'`f' _n
							if (`ATE'==1) file write EATE`j'`f' _n
							if (`ATE'==1) file write ETTE`j'`f' _n
							if (`D'==1) file write Eydi`j'`f' _n
							if (`D'==1 & "`simchoice'"!="") file write ED`j'`f' _n
						}	
						forvalues h = 1/`grid' {	
							if `j'<`f' {
								if (`Y'==1) qui sum Ey if gridstep`j'==`i' & gridstep`f'==`h'
								if (`Y'==1) file write Ey`j'`f' "`r(mean)'" _tab
								if `ATE'==1 {
									qui sum EATE if gridstep`j'==`i' & gridstep`f'==`h'
									file write EATE`j'`f' "`r(mean)'" _tab		
									qui sum ETTE if gridstep`j'==`i' & gridstep`f'==`h'
									file write ETTE`j'`f' "`r(mean)'" _tab														
								}
								if `D'==1 {
	//								qui sum Eydi if gridstep`j'==`i' & gridstep`f'==`h'
	//								local Eydim = `r(mean)'
									if `Y'==1 {
										qui sum Eyin if gridstep`j'==`i' & gridstep`f'==`h'
										file write Eydi`j'`f' "`r(mean)'" _tab // "`Eydim'" _tab 
									}	
									if "`simchoice'"!="" {
										qui sum ED if gridstep`j'==`i' & gridstep`f'==`h'
										file write ED`j'`f' "`r(mean)'" _tab
									}						
								}							
							}						
						}
						if `j'==`f' {
							if `Y'==1 {
								qui sum Ey if gridstep`j'==`i'
								local ciu = `r(mean)'+(1.96*`se_`j'_`i'')
								local cid = `r(mean)'-(1.96*`se_`j'_`i'')						
								file write Ey`j'`f' "`r(mean)'" _tab "`cid'" _tab "`ciu'" _tab
							}	
							if `ATE'==1 {
								qui sum EATE if gridstep`j'==`i'
								local ciu = `r(mean)'+(1.96*`seATE_`j'_`i'')
								local cid = `r(mean)'-(1.96*`seATE_`j'_`i'')						
								file write EATE`j'`f' "`r(mean)'" _tab "`cid'" _tab "`ciu'" _tab	
								qui sum ETTE if gridstep`j'==`i'
								file write ETTE`j'`f' "`r(mean)'" _tab					
							}
							if `D'==1 {
	//							qui sum Eydi if gridstep`j'==`i'
	//							local Eydim = `r(mean)'
								if `Y'==1 { 
									qui sum Eyin if gridstep`j'==`i'
									file write Eydi`j'`f' "`r(mean)'" _tab // "`Eydim'" _tab
								}	
								if "`simchoice'"!="" {
									qui sum ED if gridstep`j'==`i'
									local ciu = `r(mean)'+(1.96*`seD_`j'_`i'')
									local cid = `r(mean)'-(1.96*`seD_`j'_`i'')						
									file write ED`j'`f' "`r(mean)'" _tab "`cid'" _tab "`ciu'" _tab								
								} 							
							}	
						}	
					}
					if (`j'<=`f' & `Y'==1) file close Ey`j'`f'
				}
			}		
			file close _all
		}
	restore	
	
	if "`bs'"=="" {
		if `Y'==1 {
			preserve
				forvalues j = 1/`realf' {
					clear
					insheet using "`simulsave'`j'`j'.txt"
					gen Quantile = _n
					tw (rarea v2 v3 Quantile, color(gs12)) (line v1 Quantile, color(navy)), /// 
						legend(order(2 1) lab(2 "Exp. Outcome") lab(1 "95% CI")) xlabel(1(1)`grid') /// 
						ytitle("Expected Outcome") title("`title`j''") saving("`graphsave'`j'", replace)
				}
			restore	
		}	
		if `D'==1 & "`simchoice'"!="" {
			preserve
				forvalues j = 1/`realf' {
					clear
					insheet using "`simulsave'`j'`j'_D.txt"
					gen Quantile = _n
					tw (rarea v2 v3 Quantile, color(gs12)) (line v1 Quantile, color(navy)), /// 
						legend(order(2 1) lab(2 "Exp. Probability") lab(1 "95% CI")) xlabel(1(1)`grid') /// 
						ytitle("Expected Probability") title("`title`j''") saving("`graphsave'`j'_D", replace)
				}
			restore	
		}
	}		
end


cap program drop simulfactjoint_bsparam
program simulfactjoint_bsparam, sortpreserve eclass
	version 11.0
	syntax anything(name=vars) [if] [in], IDVAR(varname) [TREATind(varname) INStrum(varlist) /// 
		FULLOUTPARLIST(namelist) V(namelist) /// /* Outcome Estimation */
		PARDIST(namelist) PARV(namelist) /// /* Factor Identification Measurement System */
		Ndraws(integer 100) grid(integer 20) /// 
		SIMULSave(string asis) EY ETTE OBS ED DIST TEST NL] // INDvarsc0(varlist) INDvarsc1(varlist) GAVARBEF(varname) loadingvbef1(real 0) loadingvbef2(real 0) PARCHOICE(namelist) VCHOICE(namelist) /* Treatment Equation */ LOADINGT(namelist) SIGT(namelist) 
	
	gettoken yvar controls: vars, parse(" ")
	marksample touse 
	markout `touse' `id' `treatind' `instrum' `indvarsc0' `indvarsc1' `gavabef' `yvar' `controls'
	local nZ : word count `instrum'
	local nZ1 = `nZ'+1
	tokenize `instrum'
	
	qui count if `touse'
	if `r(N)' == 0 {
		error 2000
	}
	local factors = 2
	
	// Outcome Equations
	local rankY = colsof(`v')
	forvalues i=1/`rankY' {
		local str "`str' _out`i'"
	}
	drawnorm `str', cov(`v') means(`fulloutparlist')

	// Factor Identification Measurement System
	local rankS = colsof(`parv')
	forvalues i=1/`rankS' {
		local strS "`strS' _pardist`i'"
	}
	drawnorm `strS', cov(`parv') means(`pardist')	
	
	mkmat `str' in 1, matrix(_outrand)
	mkmat `strS' in 1, matrix(_distrand)
	
	matnames `v'
	local a r(c)
	mat coln _outrand = ``a''
	
	matnames `parv'
	local b r(c)	
	mat coln _distrand = ``b''
	
	local ftreatind = "`treatind'"  // Issue with prefixes
	local treatind = substr("`treatind'",2,.)
	
	mat gamat = _outrand[1,"`ftreatind':"]
	mat av1 = _outrand[1,"av21:_cons"]
	local av1 = el(av1,1,1)
	mat av2 = _outrand[1,"av22:_cons"]
	local av2 = el(av2,1,1)		

	forvalues d=0/1 {
		mat y`d'mat = _outrand[1,"`yvar'`d':"]
		if "`nl'"=="" {
			mat sY`d' = _outrand[1,"sY`d':_cons"]
			local sY`d' = el(sY`d',1,1)	
		}
		if "`nl'"=="nl" {
			local sY`d' = 0	
		}		
		mat aY`d'1 = _outrand[1,"a`d'1:_cons"]
		local aY`d'1 = el(aY`d'1,1,1)
		mat aY`d'2 = _outrand[1,"a`d'2:_cons"]
		local aY`d'2 = el(aY`d'2,1,1)		
	}	

	forvalues i=1/2 {
		forvalues f=1/2 {
			mat sf`i'`f'mat = _distrand[1,"sigf`i'`f':_cons"]
			local sf`i'`f' = el(sf`i'`f'mat,1,1)
		}
		mat m`i'1mat = _distrand[1,"mu`i'1:_cons"]
		local m`i'1 = el(m`i'1mat,1,1)		
		mat r`i'mat = _distrand[1,"rho`i':_cons"]
		local r`i' = el(r`i'mat,1,1)		
	}
	mat p1mat = _distrand[1,"p1:_cons"]
	local p1 = el(p1mat,1,1)	
	
	local Trank = `rankS'-8      // taking out the dist parameters
	mat Tmat = `pardist'[1,`Trank'..`rankS']
	mat vTmat = `parv'[`Trank'..`rankS',`Trank'..`rankS']
	
	
	simulfactjoint `vars' if `touse', idvar(`idvar') ndraws(`ndraws') grid(`grid') ///
		gavector(gamat) loadingv1(`av1') loadingv2(`av2') /// 
		y1vector(y1mat) loadingy11(`aY11') loadingy12(`aY12') sigy1(`sY1') /// 
		y0vector(y0mat) loadingy01(`aY01') loadingy02(`aY02') sigy0(`sY0') /// 
		sigmamixt11(`sf11') sigmamixt12(`sf12') mumixt1(`m11') mixtprob(`p1') ///		
		sigmamixt21(`sf21') sigmamixt22(`sf22') mumixt2(`m21') rmixt1(`r1') rmixt2(`r2') ///	
		instrum(`instrum') treatind(`ftreatind') /// 
		 `ette' bs `dist' simulsave(`simulsave') `nl'
		
//		indvarsc0(`indvarsc0') indvarsc1(`indvarsc1') gavarbef(`gavarbef') loadingvbef1(`loadingvbef1') loadingvbef2(`loadingvbef2') /// 			
//		loadingt(`loadingt') sigt(`sigt') /// 		
//		 `ey' `ate' `obs' `ed'  `test' 
		
	drop `str' `strS'
	cap mat drop gamat
	local `str' 
	local `strS'

	tempname b V
	mat `b' = e(b1)
	ereturn post `b'

end

cap program drop simulfactjointFS_bsparam
program simulfactjointFS_bsparam, sortpreserve eclass
	version 11.0
	syntax anything(name=id) [if] [in], /// 
		[INDvarsc0(varlist) INDvarsc1(varlist) GAVARBEF(varname) loadingvbef1(real 0) loadingvbef2(real 0) /// 
		PARDIST(namelist) PARV(namelist) /// /* Factor Identification Measurement System */
		Ndraws(integer 100) grid(integer 20) /// 
		LOADINGT(namelist) SIGT(namelist) /// 
		SIMULSave(string asis) DIST TEST]
		
	marksample touse 
	markout `touse' `id' `treatind' `instrum'
	local nZ : word count `instrum'
	local nZ1 = `nZ'+1
	tokenize `instrum'
	
	qui count if `touse'
	if `r(N)' == 0 {
		error 2000
	}
	local factors = 2
	
	local S = colsof(`parv')
	local reqS = `S'-8
	mat _`pardist' =`pardist'[1,`reqS'..`S']
	mat _`parv' = `parv'[`reqS'..`S',`reqS'..`S']
	local S = colsof(_`parv')
	
	foreach l in S {
		local str_`l'
		local L = lower("`l'")
		forvalues c=1/``l'' {
			local str_`l' "`str_`l'' _`L'`c'"
		}			
	}
	drawnorm `str_S', cov(_`parv') means(_`pardist')
	
	foreach i in `str_S' {
		local s`i' = `i' in 1
	}
	
	simulfactjointFS `id' if `touse', /// 
		indvarsc0(`indvarsc0') indvarsc1(`indvarsc1') gavarbef(`gavarbef') loadingvbef1(`loadingvbef1') loadingvbef2(`loadingvbef2') /// 
		ndraws(`ndraws') grid(`grid') /// 
		loadingt(`loadingt') sigt(`sigt') /// 		
		sigmamixt11(`s_s1') sigmamixt12(`s_s2') mumixt1(`s_s6') mixtprob(`s_s5') ///		
		sigmamixt21(`s_s3') sigmamixt22(`s_s4') mumixt2(`s_s7') rmixt1(`s_s8') rmixt2(`s_s9') /// 
		`dist' simulsave(`simulsave')
		
	drop _s*

	tempname b V
	mat `b' = e(b1)
	ereturn post `b'

end

cap program drop simulfactjointFS
program simulfactjointFS , sortpreserve eclass
	syntax anything(name=idvar) [if] [in], /// 
		[INDvarsc0(varlist) INDvarsc1(varlist) GAVARBEF(varname) loadingvbef1(real 0) loadingvbef2(real 0) /// 
		Ndraws(integer 100) grid(integer 20) /// 
		loadingt(namelist) SIGT(namelist) /// 
		sigmamixt11(real 0) sigmamixt12(real 0) mumixt1(real 0) mixtprob(real 0) ///		
		sigmamixt21(real 0) sigmamixt22(real 0) mumixt2(real 0) rmixt1(real 0) rmixt2(real 0) /// 
		DIST SIMULSave(string asis)]

	marksample touse 		
	markout `touse' `idvar' `indvarsc0' `indvarsc1' `gavarbef' 
	
	if "`indvarsc0'"!="" {
		cap mat drop SeT
		local nscores : word count `indvarsc0'	
		forvalues d=0/1 {
			tokenize `indvarsc`d''
			forvalues T = 1/`nscores' {
				tempvar T`T'`d'
				qui gen `T`T'`d''  = ``T''
			}				
		}
		local strT 
		local strTd
		forvalues d=1(-1)0 {
			forvalues T = 1/`nscores' {
				if `d'==0 local TT = `T'+`nscores'
				else local TT = `T'
				forvalues f=1/2 {
					local loadingT`T'`f'`d' = `loadingt'[`TT',`f']
				}
				local seT`T' = exp(`sigt'[1,`TT'])
				mat SeT = nullmat(SeT), `seT`T''
				if `d'==0 local strT "`strT' T`T'"
				local strTd "`strTd' `T`T'`d''"
			}		
		}
		mat SeT = diag((SeT,1))
		local strT "`strT' `gavarbef' EDbef"
		local strTd "`strTd' `gavarbef'"
	}	
	
	local factors = 2   // because joint
	local realf=`factors'	

	if (`sigmamixt11'==0 & `sigmamixt12'==0 & `mumixt1'==0 & `mixtprob'==0) { 
		di as error "Need to provide distribution parameters for at least one factor"
		exit
	}		

	qui count if `touse'
	if `r(N)' == 0 {
		error 2000
	}	
	local totobs = `r(N)' 
		
	preserve
		qui keep if `touse'
		qui des,s
		local idobs = `r(N)'

		di as text "Simulations (" as result "`ndraws'" as text ")"
		di as text "----|--- 1 ---|--- 2 ---|--- 3 ---|--- 4 ---|--- 5"
		forvalues i=1/`ndraws' {
		
			qui random_dist2f `sigmamixt11' `sigmamixt12' `sigmamixt21' `sigmamixt22' `mixtprob' `mumixt1' `mumixt2' `rmixt1' `rmixt2'
			drawnorm eT11 eT21 eT31 eT41 eT51 eT61 eT10 eT20 eT30 eT40 eT50 eT60 epsbef, cov(SeT)
			qui gen EDbef = (`gavarbef' + (`loadingvbef1'*mixt1) + (`loadingvbef2'*mixt2) + epsbef>0)
			forvalues T = 1/`nscores' {
				forvalues d=0/1 {
					qui gen T`T'`d' = `T`T'`d'' + (`loadingT`T'1`d''*mixt1) + (`loadingT`T'2`d''*mixt2) + eT`T'`d' if EDbef==`d'
//					xtile qT`T'`d' = T`T'`d'  if EDbef==`d', n(10)
				}
				qui gen T`T' = T`T'0
				qui replace T`T' = T`T'1 if T`T'==.
				drop T`T'0 T`T'1
			}				
			
			rename mixt1 _mixt1_
			rename mixt2 _mixt2_
			keep _mixt1_ _mixt2_ `touse' `strT' `strTd' `idvar' //qT*
			gen rep = `i'
			tempfile rep`i'
			qui save `rep`i''
			keep `idvar' `touse' `strTd' 
			di _continue as text "."
			local ind = round(`i'/50) - (`i'/50)
			if (`ind'==0) di as text "(`i')" 			

		}	
		drop _all
		use `rep1'
		forvalues i=2/`ndraws' {
			append using `rep`i''
		}
			
		local lss=strlen(`simulsave')
		local simulsave =substr(`simulsave',1,`lss')
		
		if "`dist'"!="" {	
			keep _mixt1_ _mixt2_ ED
			tempfile allsims
			save `allsims'
			keep if ED==0
			drop ED
			save "`simulsave'/DistfED0", replace
			use `allsims'
			keep if ED==1
			drop ED
			save "`simulsave'/DistfED1", replace
			mat b = 1
		}
		if "`indvarsc0'"!="" {	
			local mqT0
			local mqT1
			local strmqT0
			local strmqT1
			forvalues T = 1/`nscores' {	
				forvalues d=0/1 {
//					forvalues q=1/10 { qui sum T`T' if qT`T'`d'==`q' local mqT`d' "`mqT`d'' \ `r(max)'" local strmqT`d' "`strmqT`d'' pT`T'`d'q`q'" }	
					_pctile T`T' if ED==`d', n(10)
					local mqT`d' "`mqT`d'' \ `r(r1)' \ `r(r2)' \ `r(r3)' \ `r(r4)' \ `r(r5)' \ `r(r6)' \ `r(r7)' \ `r(r8)' \ `r(r9)'"
					local strmqT`d' "`strmqT`d'' pT`T'`d'q1 pT`T'`d'q2 pT`T'`d'q3 pT`T'`d'q4 pT`T'`d'q5 pT`T'`d'q6 pT`T'`d'q7 pT`T'`d'q8 pT`T'`d'q9"
				}	
			}
			mat b = 1 `mqT0' `mqT1'
			mat rown b = anchor `strmqT0' `strmqT1'
			keep T? EDbef			
			save "`simulsave'/TestsW1", replace			
		}
						
		mat coln b = Ests
		mat b = b'
		ereturn mat b1=b	
	restore	
			
	foreach i in SeT {
		cap mat drop `i'
	}
end

				
mata:
real matrix gradn(string scalar b, /// 
				  string scalar z)
{

	meanz = st_matrix(z)
	vector1 = st_matrix(b)	

	G = normalden(vector1*meanz) :* meanz

	st_matrix("grats",G)  
}
end				

