cap program drop simulfactjoint_mpc
program simulfactjoint_mpc, sortpreserve eclass
	syntax anything(name=vars) [if] [in], IDVAR(varname) ///
		[Ndraws(integer 100) grid(integer 20) /// 
		GAVECTOR(namelist) loadingv1(real 0) loadingv2(real 0) /// 
		y1vector(namelist) loadingy11(real 0) loadingy12(real 0) SIGY1(real 0) ///
		y0vector(namelist) loadingy01(real 0) loadingy02(real 0) SIGY0(real 0) ///
		sigmamixt11(real 0) sigmamixt12(real 0) mumixt1(real 0) mixtprob(real 0) ///		
		sigmamixt21(real 0) sigmamixt22(real 0) mumixt2(real 0) rmixt1(real 0) rmixt2(real 0) /// 
		TREATind(varname) INStrum(varlist) ette BS DIST NL  ///
		MPCVAR(varlist)] 	
		
/*		simulsave(string asis)
		 FACTORS(integer 1) /// 
		  V(namelist) CENTER(real 0) /// 

		title1(string asis) title2(string asis)  /// 
		graphsave(string asis)  EVALP(integer 50) /// 
		CRITVAL(real 1.96) SIMCHOICE LOGY FACTDENS ]
*/		
		
	gettoken yvar controls: vars, parse(" ")
	marksample touse 
	markout `touse' `controls' `treatind' `instrum'

	local factors=2      // # of Factors have to be 2. We are in a correlated world
	local realf=`factors'

	qui count if `touse'
	if `r(N)' == 0 {
		error 2000
	}	
	local totobs = `r(N)'
	forvalues d=0/1 {
		qui count if `touse' & `treatind'==`d'
		local totobs`d' = `r(N)'
	}	
	local ATE=("`y0vector'"!="")
	local D =("`gavector'"!="")
	local Y =("`y1vector'"!="" & "`y0vector'"=="")
		
	mat ve = 1,(exp(`sigy1'))^2,(exp(`sigy0'))^2
	mat varerror = diag(ve)
	mat drop ve
	
	tempvar intr1 intr0 intrG intrG_MPC 
	mat score `intr1' = `y1vector'
	if (`ATE'==1) mat score `intr0' = `y0vector'
	if (`D'==1) mat score `intrG' = `gavector'
	
	// Marginal Policy Change
	local nmpc : word count `mpcvar'
	tokenize `mpcvar'
	forvalues i=1/`nmpc' {
		tempvar basempc``i''
		gen `basempc``i''' = ``i''
		drop ``i''
		rename ``i''mpc ``i''     // Changing the variable that we are isolating
		capture confirm variable ``i''2
		if !_rc {
			tempvar basempc``i''2
			gen `basempc``i''2' = ``i''2
			drop ``i''2
			rename ``i''2mpc ``i''2  
		}
	}
	mat score `intrG_MPC' = `gavector'
	forvalues i=1/`nmpc' {		
		rename ``i'' ``i''mpc 
		rename `basempc``i''' ``i''
		capture confirm variable ``i''2
		if !_rc {
			rename ``i''2 ``i''2mpc 
			rename `basempc``i''2' ``i''2		
		}
	}
	
	preserve
		//tempvar intrG_MPC
		
		
		
		qui keep if `touse'
		qui des,s
		local idobs = `r(N)'
		di "Using `r(N)' observations" _n
		
		qui sum `yvar'
		local meany = `r(mean)'
		local sdy = `r(sd)'
		if `D'==1 {
			qui sum `treatind'
			local meand = `r(mean)'
			
			local stringD "ED ED_MPC"		
		}	
		if `ATE'==1 {
			tempvar expy
			qui sum `yvar' if `treatind'==1
			local meany1 = `r(mean)'
			local sdy1 = `r(sd)'			
			qui sum `yvar' if `treatind'==0
			local meany0 = `r(mean)'
			local sdy0 = `r(sd)'	

			if "`logy'"!="" local streATE "eEy Ey eEy0 Ey0 EATE ETTE"
			else local streATE "EATE_MPC ETTE ETUE"											
		}
		if (`Y'==1) local strEylwcy "Ey"
			
		di as text "Simulations (" as result "`ndraws'" as text ")"
		di as text "----|--- 1 ---|--- 2 ---|--- 3 ---|--- 4 ---|--- 5"
		forvalues i=1/`ndraws' {	
			
			qui random_dist2f `sigmamixt11' `sigmamixt12' `sigmamixt21' `sigmamixt22' `mixtprob' `mumixt1' `mumixt2' `rmixt1' `rmixt2'
			qui drawnorm eps error1 error0, cov(varerror)
			rename mixt1 _mixt1_
			rename mixt2 _mixt2_
	
			qui gen ED = (`intrG' + (`loadingv1'*_mixt1_) + (`loadingv2'*_mixt2_) + eps>0)
			qui gen ED_MPC = (`intrG_MPC' + (`loadingv1'*_mixt1_) + (`loadingv2'*_mixt2_) + eps>0)
*noi sum ED ED_MPC

			if `ATE'==1 {						
				if "`logy'"=="" & "`nl'"=="" {
					qui gen EATE_MPC = -(`intr1' - `intr0' + ((`loadingy11'-`loadingy01')*_mixt1_) + ((`loadingy12'-`loadingy02')*_mixt2_)) if ED==1 & ED_MPC==0					
					qui gen ETTE = -(`intr1' - `intr0' + ((`loadingy11'-`loadingy01')*_mixt1_) + ((`loadingy12'-`loadingy02')*_mixt2_)) if ED==1
					qui gen ETUE = -(`intr1' - `intr0' + ((`loadingy11'-`loadingy01')*_mixt1_) + ((`loadingy12'-`loadingy02')*_mixt2_)) if ED==0
				}	
				else {
					di as error "Non-linear models not allowed"
					exit
				}
			}	
			
			keep _mixt1_ _mixt2_ `strEylwcy' `streATE' `strEyin' `stringD' `idvar' `treatind' `controls' `touse' `intr1' `intr0' `intrG' `intrG_MPC'
			gen rep = `i'
			tempfile rep`i'
			qui save `rep`i''
			keep `idvar' `treatind' `controls' `strgavr' `touse' `intr1' `intr0' `intrG' `intrG_MPC'
			di _continue as text "."
			local ind = round(`i'/50) - (`i'/50)
			if (`ind'==0) di as text "(`i')" 			

		}	
		drop _all
		use `rep1'
		forvalues i=2/`ndraws' {
			append using `rep`i''
		}
		if "`dist'"!="" | "`test'"!="" {
			local lss=strlen(`simulsave')
			local simulsave =substr(`simulsave',1,`lss')
		}	
		if "`dist'"!="" {	
			keep _mixt1_ _mixt2_ ED
			tempfile allsims
			save `allsims'
			keep if ED==0
			drop ED
			save "`simulsave'/DistfED0", replace
			use `allsims'
			keep if ED==1
			drop ED
			save "`simulsave'/DistfED1", replace
		}		
		if "`test'"!="" {		
			keep T? EDbef			
			save "`simulsave'/TestsW1", replace
		}
		if "`dist'"!="" | "`test'"!="" {
			mat b = 1
			ereturn mat b1=b
			exit
		}		

		di _newline as text "Estimating Marginal Effects" _newline
			
		qui distinct `idvar'
		local N = `r(ndistinct)'			
		
		forvalues i = 1/`factors' {
			xtile gridstep`i' =_mixt`i'_, n(`grid') 
		}		

		if `ATE'==1 {	
			qui sum EATE_MPC
			if `r(N)'>=20 local mEATE_MPC = `r(mean)'
			else local mEATE_MPC = 0 
			qui sum ETTE
			local mETTE = `r(mean)'				
			qui sum ETUE
			local mETUE = `r(mean)'				

			* moments of each quantile
			local strmEATE 
			local strNamemEATE
			local strmETTE 
			local strNamemETTE
			local strmETUE 
			local strNamemETUE

			forvalues j = 1/`realf' {
				forvalues f = 1/`realf' {
					forvalues i = 1/`grid' {
																			
						forvalues h = 1/`grid' {
							if `f'>`j' {
								qui sum EATE_MPC if gridstep`j'==`i' & gridstep`f'==`h'
								if `r(N)'<20 local strmEATE "`strmEATE' \ 0 \ 0 "
								if `r(N)'>=20 local strmEATE "`strmEATE' \ `r(mean)' \ `r(sd)'"
								local strNamemEATE "`strNamemEATE' EATE_`j'`f'_`i'`h' sEATE_`j'`f'_`i'`h'"
								if "`ette'"!="" {
									qui sum ETTE if gridstep`j'==`i' & gridstep`f'==`h'
									if `r(N)'<20 local strmETTE "`strmETTE' \ 0 \ 0 "
									if `r(N)'>=20 local strmETTE "`strmETTE' \ `r(mean)' \ `r(sd)'"
									local strNamemETTE "`strNamemETTE' ETTE_`j'`f'_`i'`h' sETTE_`j'`f'_`i'`h'"
								}	
							}	
						}							
					}
				}		
			}	
		}				
	 
		if `D'==1 {
			qui sum ED 
			local mD = `r(mean)'
			local sD = `r(sd)'
			qui sum ED_MPC 
			local mD_MPC = `r(mean)'
			local sD_MPC = `r(sd)'			
		}
			
//		tempfile mixtlong
//		qui save `mixtlong', replace
				
		if `D'==0 {
			mat b = `mEy'
			mat rown b = EY
		}
		if `ATE'==1 {
			if "`ette'"!="" {
				local strmEATE 
				local strNamemEATE 
			}
			if "`ette'"=="" {
				local strmETTE
				local strNamemETTE				
			}
			mat b = `mD' \ `mD_MPC' \ `mEATE_MPC' \ `mETTE' \ `mETUE' `strmEATE' `strmETTE' \ `sD' \ `sD_MPC' 
			mat rown b = ED ED_MPC EATE_MPC ETTE ETUE `strNamemEATE' `strNamemETTE' sD sD_MPC 
		}	
		mat coln b = "`yvar'"
		mat b = b'
		ereturn mat b1=b
				
	restore	
	
end


cap program drop simulfactjoint_bsparam_mpc
program simulfactjoint_bsparam_mpc, sortpreserve eclass
	version 11.0
	syntax anything(name=vars) [if] [in], IDVAR(varname) [TREATind(varname) INStrum(varlist) /// 
		FULLOUTPARLIST(namelist) V(namelist) /// /* Outcome Estimation */
		PARDIST(namelist) PARV(namelist) /// /* Factor Identification Measurement System */
		Ndraws(integer 100) grid(integer 20) /// 
		MPCVAR(varlist) EY ETTE OBS ED DIST TEST NL] // SIMULSave(string asis)  INDvarsc0(varlist) INDvarsc1(varlist) GAVARBEF(varname) loadingvbef1(real 0) loadingvbef2(real 0) PARCHOICE(namelist) VCHOICE(namelist) /* Treatment Equation */ LOADINGT(namelist) SIGT(namelist) 
	
	gettoken yvar controls: vars, parse(" ")
	marksample touse 
	markout `touse' `id' `treatind' `instrum' `indvarsc0' `indvarsc1' `gavabef' `yvar' `controls'
	local nZ : word count `instrum'
	local nZ1 = `nZ'+1
	tokenize `instrum'
	
	qui count if `touse'
	if `r(N)' == 0 {
		error 2000
	}
	local factors = 2
	
	// Outcome Equations
	local rankY = colsof(`v')
	forvalues i=1/`rankY' {
		local str "`str' _out`i'"
	}
	drawnorm `str', cov(`v') means(`fulloutparlist')

	// Factor Identification Measurement System
	local rankS = colsof(`parv')
	forvalues i=1/`rankS' {
		local strS "`strS' _pardist`i'"
	}
	drawnorm `strS', cov(`parv') means(`pardist')	
	
	mkmat `str' in 1, matrix(_outrand)
	mkmat `strS' in 1, matrix(_distrand)
	
	matnames `v'
	local a r(c)
	mat coln _outrand = ``a''
	
	matnames `parv'
	local b r(c)	
	mat coln _distrand = ``b''
	
	local ftreatind = "`treatind'"  // Issue with prefixes
	local treatind = substr("`treatind'",2,.)
	
	mat gamat = _outrand[1,"`ftreatind':"]
	mat av1 = _outrand[1,"av21:_cons"]
	local av1 = el(av1,1,1)
	mat av2 = _outrand[1,"av22:_cons"]
	local av2 = el(av2,1,1)		

	forvalues d=0/1 {
		mat y`d'mat = _outrand[1,"`yvar'`d':"]
		if "`nl'"=="" {
			mat sY`d' = _outrand[1,"sY`d':_cons"]
			local sY`d' = el(sY`d',1,1)	
		}
		if "`nl'"=="nl" {
			local sY`d' = 0	
		}		
		mat aY`d'1 = _outrand[1,"a`d'1:_cons"]
		local aY`d'1 = el(aY`d'1,1,1)
		mat aY`d'2 = _outrand[1,"a`d'2:_cons"]
		local aY`d'2 = el(aY`d'2,1,1)		
	}	

	forvalues i=1/2 {
		forvalues f=1/2 {
			mat sf`i'`f'mat = _distrand[1,"sigf`i'`f':_cons"]
			local sf`i'`f' = el(sf`i'`f'mat,1,1)
		}
		mat m`i'1mat = _distrand[1,"mu`i'1:_cons"]
		local m`i'1 = el(m`i'1mat,1,1)		
		mat r`i'mat = _distrand[1,"rho`i':_cons"]
		local r`i' = el(r`i'mat,1,1)		
	}
	mat p1mat = _distrand[1,"p1:_cons"]
	local p1 = el(p1mat,1,1)	
	
	local Trank = `rankS'-8      // taking out the dist parameters
	mat Tmat = `pardist'[1,`Trank'..`rankS']
	mat vTmat = `parv'[`Trank'..`rankS',`Trank'..`rankS']
	
	
	simulfactjoint_mpc `vars' if `touse', idvar(`idvar') ndraws(`ndraws') grid(`grid') ///
		gavector(gamat) loadingv1(`av1') loadingv2(`av2') /// 
		y1vector(y1mat) loadingy11(`aY11') loadingy12(`aY12') sigy1(`sY1') /// 
		y0vector(y0mat) loadingy01(`aY01') loadingy02(`aY02') sigy0(`sY0') /// 
		sigmamixt11(`sf11') sigmamixt12(`sf12') mumixt1(`m11') mixtprob(`p1') ///		
		sigmamixt21(`sf21') sigmamixt22(`sf22') mumixt2(`m21') rmixt1(`r1') rmixt2(`r2') ///	
		instrum(`instrum') treatind(`ftreatind') mpcvar(`mpcvar') /// 
		 `ette' bs `dist'  `nl'
		
//		simulsave(`simulsave') indvarsc0(`indvarsc0') indvarsc1(`indvarsc1') gavarbef(`gavarbef') loadingvbef1(`loadingvbef1') loadingvbef2(`loadingvbef2') /// 			
//		loadingt(`loadingt') sigt(`sigt') /// 		
//		 `ey' `ate' `obs' `ed'  `test' 
		
	drop `str' `strS'
	cap mat drop gamat
	local `str' 
	local `strS'

	tempname b V
	mat `b' = e(b1)
	ereturn post `b'

end
